//================================================================================
//  
//        SDR-1.h
//  
//        (c)2010/10/31  by OjisanKoubou
//  
//================================================================================
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
//  ƓIp͂߂B
//

#ifndef __SDR_1_H__
#define __SDR_1_H__

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include <math.h>


//
//      n[hEFA`
//

#define PDPOLARITY_H  (_SFR_BYTE(PORTB) |=  _BV(2))
#define PDPOLARITY_L  (_SFR_BYTE(PORTB) &= ~_BV(2))
#define PD_H          ( DDRB = 0x3F )
#define PD_L          ( DDRB = 0x3B )   // PB2 ̓|[gɂ

#define LCDC_V_H    (_SFR_BYTE(PORTD) |=  _BV(7))
#define LCDC_V_L    (_SFR_BYTE(PORTD) &= ~_BV(7))

#define CPU_CLOCK   24576000L           // NbNg

#define SW_DIRIN    (DDRC = 0x00);      // 
#define SW_DIROUT   (DDRC = 0x3F);      // 
#define SW_PULLUP   (PORTC= 0x0F);      // 

#define SW_PORT_DDR (DDRC)
#define SW_PORT     (PORTC)
#define SW_IN       (PINC)
#define SW_MASK     (0x0F)
#define SW1         (0x01)
#define SW2         (0x02)
#define SW3         (0x04)
#define SW4         (0x08)

#define LED1_ON     (_SFR_BYTE(PORTB) |=  _BV(0))   // CN1(9)   IC1(14)
#define LED1_OFF    (_SFR_BYTE(PORTB) &= ~_BV(0))
#define LED2_ON     (_SFR_BYTE(PORTB) |=  _BV(1))   // CN1(10)  IC1(15)
#define LED2_OFF    (_SFR_BYTE(PORTB) &= ~_BV(1))
#define LED3_ON     (_SFR_BYTE(PORTD) |=  _BV(2))   // LED3     IC1(4)
#define LED3_OFF    (_SFR_BYTE(PORTD) &= ~_BV(2))

#define LCDC_DATA   PORTC               // kbcf[^Ȃ|[g
#define LCDC_CTRL   PORTC               // kbc(E,RS)Ȃ|[g
#define LCDC_E      PC4                 // E  ̃rbgʒu
#define LCDC_RS     PC5                 // RS ̃rbgʒu

#define LCDC_MAX_Y  (4)                 // kbcW[s@Qs͂Ss

#define SW_LEFT     (SW4)               //    vol-
#define SW_RIGHT    (SW3)               //    vol+
#define SW_DOWN     (SW2)               //    freq-
#define SW_UP       (SW1)               //    freq+

#define L3PORT      PORTB                // UDA1345 L3 C^[tF[X
#define L3DATA      PB3
#define L3MODE      PB4
#define L3CLK       PB5
#define L3DATA_H()  sbi( L3PORT, L3DATA )
#define L3DATA_L()  cbi( L3PORT, L3DATA )
#define L3MODE_H()  sbi( L3PORT, L3MODE )
#define L3MODE_L()  cbi( L3PORT, L3MODE )
#define L3CLK_H()   sbi( L3PORT, L3CLK )
#define L3CLK_L()   cbi( L3PORT, L3CLK )


//
//      ݒ
//
#define PAGE_N        4                 // y[W
#define STA_N         10                // Py[W̋ǐ
#define VOLUME_MAX    40



//
//      VXe
//
#define loc_cpu()   cli()     // 荞ݕs
#define unl_cpu()   sei()     // 荞݉


//
//      萔`
//
//#define NULL     (void *)(0)
#define TRUE     (1)
#define FALSE    (0)

#define ENABLE   (1)
#define DISABLE  (0)

#define ERR      (-1)

#define BS       (0x08)       // \b
#define TAB      (0x09)       // \t
#define LF       (0x0a)       // \n
#define VT       (0x0b)       // \v
#define FF       (0x0c)       // \f
#define CR       (0x0d)       // \r
#define ESC      (0x1b)       // 

//#define NOP asm volatile("nop\t\n")


//
//      ^`
//
typedef signed char     B;
typedef signed short    H;
typedef signed long     W;
typedef unsigned char   UB;
typedef unsigned short  UH;
typedef unsigned long   UW;
typedef signed char     BOOL;
typedef unsigned char   ID;
typedef unsigned char   RELTIM;
typedef unsigned short  SYSTIM;
typedef unsigned short  FLAG;
typedef unsigned char   TSK_STA;

typedef signed char     int8;
typedef signed short    int16;
typedef signed long     int32;
typedef unsigned char   uint8;
typedef unsigned short  uint16;
typedef unsigned long   uint32;
typedef signed char     bool;


//
//      }N`
//
#define outp(data, sfr)  (_SFR_BYTE(sfr) = data)
#define inp(port)        (port)
#define inb(port)        (port)
#define sbi(sfr, bit)    (_SFR_BYTE(sfr) |= _BV(bit))
#define cbi(sfr, bit)    (_SFR_BYTE(sfr) &= ~_BV(bit))
#define PRG_RDB(addr)    (pgm_read_byte(addr))
#define BV(bit)          (1<<(bit))
#define nop              __asm__ __volatile__( "  nop\n\t" : )



//
//      ֐vg^Cv
//
void userprogram_init( void );
void hardware_init( void );
void adda_start( void );
int main( void );
void set_freq( void );
void set_station( int8 d );


//
//      ̃wb_[
//
#include "dec2str.h"
#include "demod.h"
#include "dispatch.h"
#include "eeprom.h"
#include "hex2str.h"
#include "lcdc16xn.h"
#include "sine.h"
#include "uda1345.h"
#include "user_interface.h"


#endif  /* __VoltAmpMeter_H__ */
